<?php 
/*
Plugin Name: Image Banner Widget
Plugin URI: http://shailan.com/wordpress/plugins/image-banner-widget
Description: This simple widget is intended for simplest use of image banners. You can use this widget to put image banners on your site. You can find more widgets, plugins and themes at <a href="shailan.com">http://shailan.com</a>.
Version: 1.2
Author: Matt Say
Author URI: http://shailan.com
*/

/**
 * Banner Widget Class
 */
 
if(!class_exists('shailan_BannerWidget')){
	class shailan_BannerWidget extends WP_Widget {
		/** constructor */
		function shailan_BannerWidget() {
			$widget_ops = array('classname' => 'shailan_banner_widget', 'description' => __( 'Image only banner' ) );
			$this->WP_Widget('banner', __('Image Banner Widget'), $widget_ops);
			$this->alt_option_name = 'widget_banner';	
			
			if(is_admin()){
				wp_enqueue_script('image-banner-scripts', WP_PLUGIN_URL . '/image-banner-widget/admin.js', 'jQuery', '', TRUE );
				wp_enqueue_style('image-banner-styles', WP_PLUGIN_URL . '/image-banner-widget/admin.css');
			}
			
			$this->widget_defaults = array(
				'url' => '',
				'link'	=> '',
				'alt' => '',
				'title' => '',
				'category' => 'shailan-show-all-categories',
				'home' => true,
				'autofit' => ''
			);
			
		}

		/** @see WP_Widget::widget */
		function widget($args, $instance) {	
			global $post;
			global $wpdb, $wp_locale, $wp_query;
		
			extract( $args );
			$widget_options = wp_parse_args( $instance, $this->widget_defaults );
			extract( $widget_options, EXTR_SKIP );
			
			$home = (bool) $home;
		
			$c1 = (is_home() && $home); // is home and home is selected
			$c2 = ((is_category() || is_single()) && $category == 'shailan-show-all-categories');
			$c3 = (is_home() && $category == 'shailan-home-only');
			$c4 = (is_single() && in_category( $category, $post->ID ));
			$c5 = (is_category($category));
			
			if( $c1 || $c2 || $c3 || $c4 || $c5 ){	
			
			echo $before_widget; ?>
				
			<a href="<?php echo $link; ?>"><img src="<?php echo $url; ?>" alt="<?php echo $alt; ?>" title="<?php echo $title; ?>" class="banner-image" <?php if($autofit){ echo 'width="100%"'; }?> /></a>
			
			<?php echo $after_widget; 
			
			}
		}

		/** @see WP_Widget::update */
		function update($new_instance, $old_instance) {				
			return $new_instance;
		}

		/** @see WP_Widget::form */
		function form($instance) {			
			$widget_options = wp_parse_args( $instance, $this->widget_defaults );
			extract( $widget_options, EXTR_SKIP );
			$home = (bool) $home;
							
			if(strlen($url)>0){
			?>
				<p><div class="ibw-thumb">
					<div class="ibw-overlay">
						<span>Preview</span>
					</div>
					
					<img src="<?php echo $url ?>" />
				</div></p>
				
			<?php } ?>
			
				<p><label for="<?php echo $this->get_field_id('url'); ?>"><?php _e('Image URL:', 'image-banner-widget'); ?> <input class="widefat" id="<?php echo $this->get_field_id('url'); ?>" name="<?php echo $this->get_field_name('url'); ?>" type="text" value="<?php echo $url; ?>" /></label><br /> 
					<small><?php _e('Enter image URL here. <br />(Eg. http://shailan.com/mybanner.jpg)', 'image-banner-widget'); ?></small></p>
				<p><label for="<?php echo $this->get_field_id('link'); ?>"><?php _e('Link:', 'image-banner-widget'); ?> <input class="widefat" id="<?php echo $this->get_field_id('link'); ?>" name="<?php echo $this->get_field_name('link'); ?>" type="text" value="<?php echo $link; ?>" /></label><br /> 
					<small><?php _e('Enter link address here.', 'image-banner-widget'); ?></small></p>
			
			<div class="ibw-advanced-toggle"><span><?php _e('Advanced Settings', 'image-banner-widget'); ?></span>
			<div class="ibw-advanced-options">
			
			<p><label for="<?php echo $this->get_field_id('alt'); ?>"><?php _e('Alt:', 'image-banner-widget'); ?> <input class="widefat" id="<?php echo $this->get_field_id('alt'); ?>" name="<?php echo $this->get_field_name('alt'); ?>" type="text" value="<?php echo $alt; ?>" /></label><br /> 
						<small><?php _e('Alternative text for non-image browsers & search engines.', 'image-banner-widget'); ?></small></p>
			<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'image-banner-widget'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label><br /> 
						<small><?php _e('Displayed as image tooltip text.', 'image-banner-widget'); ?></small></p>
			
			<p><label for="<?php echo $this->get_field_id('category'); ?>"><?php _e('Display for:'); ?><select name="<?php echo $this->get_field_name('category'); ?>" id="<?php echo $this->get_field_id('category'); ?>" > 	
			<option value="shailan-show-all-categories" <?php if('shailan-show-all-categories' == $category){ echo "selected=\"selected\""; } ?> >All categories</option>		
			<option value="shailan-home-only" <?php if('shailan-home-only' == $category){ echo "selected=\"selected\""; } ?> >Homepage only</option>		
 <?php 
  $categories = get_categories(''); 
  foreach ($categories as $cat) {  
  	$option = '<option value="'.$cat->category_nicename .'" '. ( $cat->category_nicename == $category ? ' selected="selected"' : '' ) .'>';
	$option .= $cat->cat_name;
	$option .= '</option>\n';
	echo $option;
  }
 ?>
</select></label></p>

		<p><input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('home'); ?>" name="<?php echo $this->get_field_name('home'); ?>"<?php checked( $home ); ?> />
		<label for="<?php echo $this->get_field_id('home'); ?>"><?php _e( 'Display on homepage'); ?></label></p>

		<p><input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('autofit'); ?>" name="<?php echo $this->get_field_name('autofit'); ?>"<?php checked( $autofit ); ?> />
		<label for="<?php echo $this->get_field_id('autofit'); ?>"><?php _e( 'Auto-fit to container width' , 'image-banner-widget'); ?></label></p>

			</div>
			</div>
			
		<div class="widget-control-actions alignright">
		<p><small><a href="http://shailan.com/wordpress/plugins/image-banner-widget"><?php _e('Visit plugin site', 'image-banner-widget'); ?></a></small></p>
		</div>		
			
				<div class="clear"></div>
				
			<?php 
			
		}
		
	} // class shailan.LoopWidget
}
// register widget
add_action('widgets_init', create_function('', 'return register_widget("shailan_BannerWidget");'));